
local Button = {}

function Button.new()
    local b = get()
    b:setSize(70, 30)
    b.color.base = {190, 190, 190}
    b.text = "Button"
    b.font = love.graphics.newFont()
    b.action = function() end
    b.color.selected = {180, 180, 180}
    b.color.text = {255, 255, 255}
    function b:draw()
        love.graphics.setColor(self.color.current)
        love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
        love.graphics.setColor(self.color.outline)
        love.graphics.rectangle("line", self.x, self.y, self.w, self.h)
        love.graphics.setColor(self.color.text)
        love.graphics.setFont(self.font)
        love.graphics.print(self.text, self.x + (self.w / 2) - (self.font:getWidth(self.text) / 2),
        self.y + (self.h / 2) - (self.font:getHeight(self.text) / 2))
    end
    function b:update(dt)
        local x, y = love.mouse.getPosition()
        if col(self.x, self.y, self.w, self.h, x, y, 15, 15) then
            self.color.current = self.color.selected
        else
            self.color.current = self.color.base
        end
    end
    function b:mousepressed(x, y, button)
        if button == "l" then
            if col(self.x, self.y, self.w, self.h, x, y, 15, 15) then
                self.action()
            end
        end
    end
    function b:setFont(font)
        self.font = font or love.graphics.newFont()
    end
    function b:setAction(action)
        self.action = action or function() end
    end
    return b
end

return Button
