
local path = ...
local gui = {}
gui.items = {}
function col(x1,y1,w1,h1, x2,y2,w2,h2) return x1 < x2+w2 and x2 < x1+w1 and y1 < y2+h2 and y2 < y1+h1 end

font123154sad = love.graphics.newFont()

get = require(path .. '.object.template')
local Window = require(path .. '.object.Window')
local Button = require(path .. '.object.Button')
local Progressbar = require(path .. '.object.Progressbar')

function gui.new(type)
    if type == "Button" then
        local b = Button.new()
        table.insert(gui.items, b)
        return b
    elseif type == "Window" then
        local w = Window.new()
        table.insert(gui.items, w)
        return w
    elseif type == "Progressbar" then
        local p = Progressbar.new()
        table.insert(gui.items, p)
        return p
    end
end

function gui.draw()
    for k, v in ipairs(gui.items) do
        v:draw()
    end
    love.graphics.setFont(font123154sad)
end

function gui.update(dt)
    for k, v in ipairs(gui.items) do
        v:update(dt)
    end
end

function gui.mousepressed(x, y, button)
    for k, v in ipairs(gui.items) do
        if v.mousepressed then
            v:mousepressed(x, y, button)
        end
    end
end

return gui
