
local Window = {}

function Window.new()
    local w = get()
    w.text = "Window"
    w.textAlign = "center"
    w.font = love.graphics.newFont()
    w.color.title = {0, 130, 255}
    w.color.titleOutline = {0, 120, 245}
    w.color.text = {255, 255, 255}
    function w:draw()
        if self.visible then
            love.graphics.setColor(self.color.base)
            love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
            love.graphics.setColor(self.color.outline)
            love.graphics.rectangle("line", self.x, self.y + 30, self.w, self.h - 30)
            love.graphics.setColor(self.color.title)
            love.graphics.rectangle("fill", self.x, self.y, self.w, 30)
            love.graphics.setColor(self.color.titleOutline)
            love.graphics.rectangle("line", self.x, self.y, self.w, 30)
            love.graphics.setColor(self.color.text)
            if self.textAlign == "center" then
                love.graphics.setFont(self.font)
                love.graphics.print(self.text, self.x + (self.w / 2) - (self.font:getWidth(self.text) / 2), self.y + 8)
            end
        end
    end
    return w
end

return Window
