
sw,sh=love.window.getDimensions()
gui = require('gui')
require('background')
require('game')
fade = require('fade')

function love.load()
    love.window.setTitle("Snake")
    state = "menu"
    play = gui.new("Button")
    quit = gui.new("Button")
    over = gui.new("Button")
    over:setText("Back to Menu")
    play:setText("Play Snake")
    quit:setText("Quit Snake")
    play:setSize(90, 30)
    play:setAction(function() state = "game" end)
    quit:setSize(90, 30)
    quit:setAction(function() love.event.quit() end)
    over:setSize(90, 30)
    over:setAction(function() state = "menu" end)
    play:setPos(35, 140)
    quit:setPos(35, 180)
    over:setPos(355, 290)
    font = love.graphics.newFont(30)
    back_load(300, 300)
    game.load()
    snend = true
    fade.load("", 2)
    fade.addImage("logo2.png", 1, 330, 200)
    fade.setReduce(4)
end

function love.draw()
    if state == "menu" then
        back_draw(300, 100)
        play:draw()
        quit:draw()
        love.graphics.setColor(255, 255, 255)
        love.graphics.setFont(font)
        love.graphics.print("Snake", 35, 50)
    elseif state == "game" then
        love.graphics.setFont(font123154sad)
        game.draw()
    elseif state == "over" then
        over:draw()
        love.graphics.setFont(font)
        love.graphics.print("Game Over", sw / 2 - font:getWidth("Game Over") / 2, 220)
        love.graphics.setFont(font123154sad)
        love.graphics.print("Score: " .. score, sw / 2 - font123154sad:getWidth("Score: " .. score) / 2, 260)
    end
    fade.draw({255, 255, 255}, {0, 0, 0})
end

function love.update(dt)
    fade.update(dt)
    if state == "menu" then
        gui.update(dt)
        back_update(dt)
        if not snend then
            game.load()
            back_load(300, 300)
            snend = true
        end
    elseif state == "over" then
        gui.update(dt)
    elseif state == "game" then
        game.update(dt)
        snend = false
    end
end

function love.keypressed(key)
    if state == "game" then
        game.keypressed(key)
    end
end

function love.mousepressed(x, y, button)
    if state == "menu" or state == "over" then
        gui.mousepressed(x, y, button)
    end
end
